from cimpy.cgmes_v2_4_15.TurbineGovernorDynamics import TurbineGovernorDynamics


class GovSteamFV4(TurbineGovernorDynamics):
	'''
	Detailed electro-hydraulic governor for steam unit.

	:kf1: Frequency bias (reciprocal of droop) (Kf1).  Typical Value = 20. Default: 0.0
	:kf3: Frequency control (reciprocal of droop) (Kf3).  Typical Value = 20. Default: 0.0
	:lps: Maximum positive power error (Lps).  Typical Value = 0.03. Default: 0.0
	:lpi: Maximum negative power error (Lpi).  Typical Value = -0.15. Default: 0.0
	:mxef: Upper limit for frequency correction (MX).  Typical Value = 0.05. Default: 0.0
	:mnef: Lower limit for frequency correction (MN).  Typical Value = -0.05. Default: 0.0
	:crmx: Maximum value of regulator set-point (Crmx).  Typical Value = 1.2. Default: 0.0
	:crmn: Minimum value of regulator set-point (Crmn).  Typical Value = 0. Default: 0.0
	:kpt: Proportional gain of electro-hydraulic regulator (Kpt).  Typical Value = 0.3. Default: 0.0
	:kit: Integral gain of electro-hydraulic regulator (Kit).  Typical Value = 0.04. Default: 0.0
	:rvgmx: Maximum value of integral regulator (Rvgmx).  Typical Value = 1.2. Default: 0.0
	:rvgmn: Minimum value of integral regulator (Rvgmn).  Typical Value = 0. Default: 0.0
	:svmx: Maximum regulator gate opening velocity (Svmx).  Typical Value = 0.0333. Default: 0.0
	:svmn: Maximum regulator gate closing velocity (Svmn).  Typical Value = -0.0333. Default: 0.0
	:srmx: Maximum valve opening (Srmx).  Typical Value = 1.1. Default: 0.0
	:srmn: Minimum valve opening (Srmn).  Typical Value = 0. Default: 0.0
	:kpp: Proportional gain of pressure feedback regulator (Kpp).  Typical Value = 1. Default: 0.0
	:kip: Integral gain of pressure feedback regulator (Kip).  Typical Value = 0.5. Default: 0.0
	:rsmimx: Maximum value of integral regulator (Rsmimx).  Typical Value = 1.1. Default: 0.0
	:rsmimn: Minimum value of integral regulator (Rsmimn).  Typical Value = 0. Default: 0.0
	:kmp1: First gain coefficient of  intercept valves characteristic (Kmp1).  Typical Value = 0.5. Default: 0.0
	:kmp2: Second gain coefficient of intercept valves characteristic (Kmp2).  Typical Value = 3.5. Default: 0.0
	:srsmp: Intercept valves characteristic discontinuity point (Srsmp).  Typical Value = 0.43. Default: 0.0
	:ta: Control valves rate opening time (Ta).  Typical Value = 0.8. Default: 0
	:tc: Control valves rate closing time (Tc).  Typical Value = 0.5. Default: 0
	:ty: Control valves servo time constant (Ty).  Typical Value = 0.1. Default: 0
	:yhpmx: Maximum control valve position (Yhpmx).  Typical Value = 1.1. Default: 0.0
	:yhpmn: Minimum control valve position (Yhpmn).  Typical Value = 0. Default: 0.0
	:tam: Intercept valves rate opening time (Tam).  Typical Value = 0.8. Default: 0
	:tcm: Intercept valves rate closing time (Tcm).  Typical Value = 0.5. Default: 0
	:ympmx: Maximum intercept valve position (Ympmx).  Typical Value = 1.1. Default: 0.0
	:ympmn: Minimum intercept valve position (Ympmn).  Typical Value = 0. Default: 0.0
	:y: Coefficient of linearized equations of turbine (Stodola formulation) (Y).  Typical Value = 0.13. Default: 0.0
	:thp: High pressure (HP) time constant of the turbine (Thp).  Typical Value = 0.15. Default: 0
	:trh: Reheater  time constant of the turbine (Trh).  Typical Value = 10. Default: 0
	:tmp: Low pressure (LP) time constant of the turbine (Tmp).  Typical Value = 0.4. Default: 0
	:khp: Fraction  of total turbine output generated by HP part (Khp).  Typical Value = 0.35. Default: 0.0
	:pr1: First value of pressure set point static characteristic (Pr1).  Typical Value = 0.2. Default: 0.0
	:pr2: Second value of pressure set point static characteristic, corresponding to Ps0 = 1.0 PU (Pr2).  Typical Value = 0.75. Default: 0.0
	:psmn: Minimum value of pressure set point static characteristic (Psmn).  Typical Value = 1. Default: 0.0
	:kpc: Proportional gain of pressure regulator (Kpc).  Typical Value = 0.5. Default: 0.0
	:kic: Integral gain of pressure regulator (Kic).  Typical Value = 0.0033. Default: 0.0
	:kdc: Derivative gain of pressure regulator (Kdc).  Typical Value = 1. Default: 0.0
	:tdc: Derivative time constant of pressure regulator (Tdc).  Typical Value = 90. Default: 0
	:cpsmx: Maximum value of pressure regulator output (Cpsmx).  Typical Value = 1. Default: 0.0
	:cpsmn: Minimum value of pressure regulator output (Cpsmn).  Typical Value = -1. Default: 0.0
	:krc: Maximum variation of fuel flow (Krc).  Typical Value = 0.05. Default: 0.0
	:tf1: Time constant of fuel regulation (Tf1).  Typical Value = 10. Default: 0
	:tf2: Time constant of steam chest (Tf2).  Typical Value = 10. Default: 0
	:tv: Boiler time constant (Tv).  Typical Value = 60. Default: 0
	:ksh: Pressure loss due to flow friction in the boiler tubes (Ksh).  Typical Value = 0.08. Default: 0.0
		'''

	cgmesProfile = TurbineGovernorDynamics.cgmesProfile

	possibleProfileList = {'class': [cgmesProfile.DY.value, ],
						'kf1': [cgmesProfile.DY.value, ],
						'kf3': [cgmesProfile.DY.value, ],
						'lps': [cgmesProfile.DY.value, ],
						'lpi': [cgmesProfile.DY.value, ],
						'mxef': [cgmesProfile.DY.value, ],
						'mnef': [cgmesProfile.DY.value, ],
						'crmx': [cgmesProfile.DY.value, ],
						'crmn': [cgmesProfile.DY.value, ],
						'kpt': [cgmesProfile.DY.value, ],
						'kit': [cgmesProfile.DY.value, ],
						'rvgmx': [cgmesProfile.DY.value, ],
						'rvgmn': [cgmesProfile.DY.value, ],
						'svmx': [cgmesProfile.DY.value, ],
						'svmn': [cgmesProfile.DY.value, ],
						'srmx': [cgmesProfile.DY.value, ],
						'srmn': [cgmesProfile.DY.value, ],
						'kpp': [cgmesProfile.DY.value, ],
						'kip': [cgmesProfile.DY.value, ],
						'rsmimx': [cgmesProfile.DY.value, ],
						'rsmimn': [cgmesProfile.DY.value, ],
						'kmp1': [cgmesProfile.DY.value, ],
						'kmp2': [cgmesProfile.DY.value, ],
						'srsmp': [cgmesProfile.DY.value, ],
						'ta': [cgmesProfile.DY.value, ],
						'tc': [cgmesProfile.DY.value, ],
						'ty': [cgmesProfile.DY.value, ],
						'yhpmx': [cgmesProfile.DY.value, ],
						'yhpmn': [cgmesProfile.DY.value, ],
						'tam': [cgmesProfile.DY.value, ],
						'tcm': [cgmesProfile.DY.value, ],
						'ympmx': [cgmesProfile.DY.value, ],
						'ympmn': [cgmesProfile.DY.value, ],
						'y': [cgmesProfile.DY.value, ],
						'thp': [cgmesProfile.DY.value, ],
						'trh': [cgmesProfile.DY.value, ],
						'tmp': [cgmesProfile.DY.value, ],
						'khp': [cgmesProfile.DY.value, ],
						'pr1': [cgmesProfile.DY.value, ],
						'pr2': [cgmesProfile.DY.value, ],
						'psmn': [cgmesProfile.DY.value, ],
						'kpc': [cgmesProfile.DY.value, ],
						'kic': [cgmesProfile.DY.value, ],
						'kdc': [cgmesProfile.DY.value, ],
						'tdc': [cgmesProfile.DY.value, ],
						'cpsmx': [cgmesProfile.DY.value, ],
						'cpsmn': [cgmesProfile.DY.value, ],
						'krc': [cgmesProfile.DY.value, ],
						'tf1': [cgmesProfile.DY.value, ],
						'tf2': [cgmesProfile.DY.value, ],
						'tv': [cgmesProfile.DY.value, ],
						'ksh': [cgmesProfile.DY.value, ],
						 }

	serializationProfile = {}

	__doc__ += '\n Documentation of parent class TurbineGovernorDynamics: \n' + TurbineGovernorDynamics.__doc__ 

	def __init__(self, kf1 = 0.0, kf3 = 0.0, lps = 0.0, lpi = 0.0, mxef = 0.0, mnef = 0.0, crmx = 0.0, crmn = 0.0, kpt = 0.0, kit = 0.0, rvgmx = 0.0, rvgmn = 0.0, svmx = 0.0, svmn = 0.0, srmx = 0.0, srmn = 0.0, kpp = 0.0, kip = 0.0, rsmimx = 0.0, rsmimn = 0.0, kmp1 = 0.0, kmp2 = 0.0, srsmp = 0.0, ta = 0, tc = 0, ty = 0, yhpmx = 0.0, yhpmn = 0.0, tam = 0, tcm = 0, ympmx = 0.0, ympmn = 0.0, y = 0.0, thp = 0, trh = 0, tmp = 0, khp = 0.0, pr1 = 0.0, pr2 = 0.0, psmn = 0.0, kpc = 0.0, kic = 0.0, kdc = 0.0, tdc = 0, cpsmx = 0.0, cpsmn = 0.0, krc = 0.0, tf1 = 0, tf2 = 0, tv = 0, ksh = 0.0,  *args, **kw_args):
		super().__init__(*args, **kw_args)
	
		self.kf1 = kf1
		self.kf3 = kf3
		self.lps = lps
		self.lpi = lpi
		self.mxef = mxef
		self.mnef = mnef
		self.crmx = crmx
		self.crmn = crmn
		self.kpt = kpt
		self.kit = kit
		self.rvgmx = rvgmx
		self.rvgmn = rvgmn
		self.svmx = svmx
		self.svmn = svmn
		self.srmx = srmx
		self.srmn = srmn
		self.kpp = kpp
		self.kip = kip
		self.rsmimx = rsmimx
		self.rsmimn = rsmimn
		self.kmp1 = kmp1
		self.kmp2 = kmp2
		self.srsmp = srsmp
		self.ta = ta
		self.tc = tc
		self.ty = ty
		self.yhpmx = yhpmx
		self.yhpmn = yhpmn
		self.tam = tam
		self.tcm = tcm
		self.ympmx = ympmx
		self.ympmn = ympmn
		self.y = y
		self.thp = thp
		self.trh = trh
		self.tmp = tmp
		self.khp = khp
		self.pr1 = pr1
		self.pr2 = pr2
		self.psmn = psmn
		self.kpc = kpc
		self.kic = kic
		self.kdc = kdc
		self.tdc = tdc
		self.cpsmx = cpsmx
		self.cpsmn = cpsmn
		self.krc = krc
		self.tf1 = tf1
		self.tf2 = tf2
		self.tv = tv
		self.ksh = ksh
		
	def __str__(self):
		str = 'class=GovSteamFV4\n'
		attributes = self.__dict__
		for key in attributes.keys():
			str = str + key + '={}\n'.format(attributes[key])
		return str
